global gOldColorDepth, gOldSoundLevel

on startMovie
  set the trace to 0
  setProp(1, 48, "puppet", 0)
  setProp(1, 48, "visibility", 1)
  unLoad()
  unloadMember()
  initPal()
  patchpal()
end

on stopMovie
  if not voidp(gOldColorDepth) then
    set the colorDepth to gOldColorDepth
  end if
  if not voidp(gOldSoundLevel) then
    set the soundLevel to gOldSoundLevel
  end if
end

on setFileName whichMember, whichFileName
  if the fileName of member whichMember <> whichFileName then
    set the fileName of member whichMember to whichFileName
  end if
end

on setFileNameLib whichMember, whichFileName
  if the fileName of castLib whichMember <> whichFileName then
    set the fileName of castLib whichMember to whichFileName
  end if
end

on initPal
  global fixPal
  if the machineType <> 256 then
    if factory("FixPalette") = 0 then
      openXLib("WRONGPAL.XOB")
    end if
    if factory("FixPalette") <> 0 then
      set fixPal to fixPalette(mnew, the stageLeft, the stageTop, the stageRight, the stageBottom)
    end if
  end if
end

on patchpal
  global fixPal
  if the machineType <> 256 then
    if factory("FixPalette") <> 0 then
      fixPal(mPatchIt)
    end if
  end if
end

on setProp startSprite, endSprite, whichProp, whichValue
  repeat with x = startSprite to endSprite
    do("set the " & whichProp & " of sprite x=whichValue")
  end repeat
end

on delayFor howLong
  set howLong to the timer + howLong
  repeat while the timer < howLong
    updateStage()
  end repeat
end
